Loading...
Searching...
No Matches
ON_NurbsSurface Class Reference

`#include <pcl/surface/3rdparty/opennurbs/opennurbs_nurbssurface.h>`

Inheritance diagram for ON_NurbsSurface:

## Public Member Functions

| ON_NurbsSurface ()
| ON_NurbsSurface (const ON_NurbsSurface &nurbs_surface)
| ON_NurbsSurface (const ON_BezierSurface &bezier_surface)
| ON_NurbsSurface (int dimension, ON_BOOL32 bIsRational, int order0, int order1, int cv_count0, int cv_count1)
unsigned int | SizeOf () const
ON__UINT32 | DataCRC (ON__UINT32 current_remainder) const
bool | IsDuplicate (const ON_NurbsSurface &other, bool bIgnoreParameterization, double tolerance=ON_ZERO_TOLERANCE) const
void | Initialize (void)
ON_BOOL32 | Create (int dim, ON_BOOL32 is_rat, int order0, int order1, int cv_count0, int cv_count1)
virtual int | CreateRuledSurface (const ON_Curve &curveA, const ON_Curve &curveB, const ON_Interval *curveA_domain=NULL, const ON_Interval *curveB_domain=NULL)
int | CreateConeSurface (ON_3dPoint apex_point, const ON_Curve &curve, const ON_Interval *curve_domain=NULL)
bool | CollapseSide (int side, ON_3dPoint point=ON_unset_point)
void | Destroy ()
virtual | ~ON_NurbsSurface ()
void | EmergencyDestroy ()
ON_NurbsSurface & | operator= (const ON_NurbsSurface &)
ON_NurbsSurface & | operator= (const ON_BezierSurface &bezier_surface)
ON_BOOL32 | IsValid (ON_TextLog *text_log=NULL) const
void | Dump (ON_TextLog &) const
ON_BOOL32 | Write (ON_BinaryArchive &) const
ON_BOOL32 | Read (ON_BinaryArchive &)
int | Dimension () const
ON_BOOL32 | GetBBox (double *, double *, ON_BOOL32=false) const
ON_BOOL32 | Transform (const ON_Xform &)
bool | IsDeformable () const
bool | MakeDeformable ()
ON_BOOL32 | SwapCoordinates (int, int)
ON_BOOL32 | SetDomain (int dir, double t0, double t1)
ON_Interval | Domain (int) const
ON_BOOL32 | GetSurfaceSize (double *width, double *height) const
int | SpanCount (int) const
ON_BOOL32 | GetSpanVector (int, double *) const
int | Degree (int) const
ON_BOOL32 | GetParameterTolerance (int, double, double *, double *) const
ON_BOOL32 | IsPlanar (ON_Plane *plane=NULL, double tolerance=ON_ZERO_TOLERANCE) const
ON_BOOL32 | IsClosed (int) const
ON_BOOL32 | IsPeriodic (int) const
ON_BOOL32 | IsSingular (int) const
bool | GetNextDiscontinuity (int dir, ON::continuity c, double t0, double t1, double *t, int *hint=NULL, int *dtype=NULL, double cos_angle_tolerance=ON_DEFAULT_ANGLE_TOLERANCE_COSINE, double curvature_tolerance=ON_SQRT_EPSILON) const
bool | IsContinuous (ON::continuity c, double s, double t, int *hint=NULL, double point_tolerance=ON_ZERO_TOLERANCE, double d1_tolerance=ON_ZERO_TOLERANCE, double d2_tolerance=ON_ZERO_TOLERANCE, double cos_angle_tolerance=ON_DEFAULT_ANGLE_TOLERANCE_COSINE, double curvature_tolerance=ON_SQRT_EPSILON) const
ON_BOOL32 | Reverse (int)
ON_BOOL32 | Transpose ()
ON_BOOL32 | Evaluate (double, double, int, int, double *, int=0, int *=0) const
ON_Curve * | IsoCurve (int dir, double c) const
ON_BOOL32 | Trim (int dir, const ON_Interval &domain)
bool | Extend (int dir, const ON_Interval &domain)
ON_BOOL32 | Split (int dir, double c, ON_Surface *&west_or_south_side, ON_Surface *&east_or_north_side) const
ON_Surface * | Offset (double offset_distance, double tolerance, double *max_deviation=NULL) const
int | GetNurbForm (ON_NurbsSurface &, double=0.0) const
double | ControlPolygonLength (int dir) const
bool | IsRational (void) const
int | CVSize (void) const
int | Order (int) const
int | CVCount (int) const
int | CVCount (void) const
int | KnotCount (int dir) const
double * | CV (int i, int j) const
ON::point_style | CVStyle () const
double | Weight (int i, int j) const
ON_BOOL32 | SetWeight (int i, int j, double weight)
ON_BOOL32 | SetCV (int i, int j, ON::point_style, const double *cv)
ON_BOOL32 | SetCV (int i, int j, const ON_3dPoint &cv)
ON_BOOL32 | SetCV (int i, int j, const ON_4dPoint &cv)
ON_BOOL32 | SetCVRow (int row_index, const ON_3dPoint &cv)
ON_BOOL32 | SetCVRow (int row_index, int v_stride, const double *v)
ON_BOOL32 | SetCVColumn (int col_index, const ON_3dPoint &cv)
ON_BOOL32 | SetCVColumn (int col_index, int v_stride, const double *v)
ON_BOOL32 | GetCV (int i, int j, ON::point_style, double *cv) const
ON_BOOL32 | GetCV (int i, int j, ON_3dPoint &cv) const
ON_BOOL32 | GetCV (int i, int j, ON_4dPoint &cv) const
int | SetKnot (int dir, int knot_index, double knot_value)
double | Knot (int dir, int knot_index) const
int | KnotMultiplicity (int dir, int knot_index) const
const double * | Knot (int dir) const
bool | MakeClampedUniformKnotVector (int dir, double delta=1.0)
bool | MakePeriodicUniformKnotVector (int dir, double delta=1.0)
bool | IsClamped (int dir, int end=2) const
double | SuperfluousKnot (int dir, int end) const
double | GrevilleAbcissa (int dir, int cv_index) const
bool | GetGrevilleAbcissae (int dir, double *g) const
bool | SetClampedGrevilleKnotVector (int dir, int g_stride, const double *g)
bool | SetPeriodicGrevilleKnotVector (int dir, int g_stride, const double *g)
bool | ZeroCVs ()
bool | ClampEnd (int dir, int end)
bool | InsertKnot (int dir, double knot_value, int knot_multiplicity=1)
bool | MakeRational ()
bool | MakeNonRational ()
bool | IncreaseDegree (int dir, int desired_degree)
bool | ChangeDimension (int desired_dimension)
ON_BOOL32 | ChangeSurfaceSeam (int dir, double t)
ON_BOOL32 | TensorProduct (const ON_NurbsCurve &, const ON_NurbsCurve &, ON_TensorProduct &)
ON_BOOL32 | ReserveKnotCapacity (int dir, int knot_array_capacity)
ON_BOOL32 | ReserveCVCapacity (int cv_array_capacity)
ON_BOOL32 | ConvertSpanToBezier (int span_index0, int span_index1, ON_BezierSurface &bezier_surface) const
Public Member Functions inherited from ON_Surface
void | DestroyRuntimeCache (bool bDelete=true)
| ON_Surface ()
| ON_Surface (const ON_Surface &)
ON_Surface & | operator= (const ON_Surface &)
virtual | ~ON_Surface ()
unsigned int | SizeOf () const
bool | EvaluatePoint (const class ON_ObjRef &objref, ON_3dPoint &P) const
virtual ON_Surface * | DuplicateSurface () const
ON::object_type | ObjectType () const
ON_BOOL32 | HasBrepForm () const
ON_Brep * | BrepForm (ON_Brep *brep=NULL) const
ON_BOOL32 | GetDomain (int dir, double *t0, double *t1) const
bool | SetDomain (int dir, ON_Interval domain)
virtual ON_BOOL32 | GetSpanVectorIndex (int dir, double t, int side, int *span_vector_index, ON_Interval *span_interval) const
virtual ISO | IsIsoparametric (const ON_Curve &curve, const ON_Interval *curve_domain=NULL) const
virtual ISO | IsIsoparametric (const ON_BoundingBox &bbox) const
bool | IsSphere (ON_Sphere *sphere=NULL, double tolerance=ON_ZERO_TOLERANCE) const
bool | IsCylinder (ON_Cylinder *cylinder=NULL, double tolerance=ON_ZERO_TOLERANCE) const
bool | IsCone (ON_Cone *cone=NULL, double tolerance=ON_ZERO_TOLERANCE) const
bool | IsTorus (ON_Torus *torus=NULL, double tolerance=ON_ZERO_TOLERANCE) const
bool | IsSolid () const
bool | IsAtSingularity (double s, double t, bool bExact=true) const
int | IsAtSeam (double s, double t) const
ON_3dPoint | PointAt (double, double) const
ON_3dVector | NormalAt (double, double) const
ON_BOOL32 | FrameAt (double u, double v, ON_Plane &frame) const
ON_BOOL32 | EvPoint (double u, double v, ON_3dPoint &point, int quadrant=0, int *hint=0) const
ON_BOOL32 | Ev1Der (double u, double v, ON_3dPoint &point, ON_3dVector &du, ON_3dVector &dv, int quadrant=0, int *hint=0) const
ON_BOOL32 | Ev2Der (double u, double v, ON_3dPoint &point, ON_3dVector &du, ON_3dVector &dv, ON_3dVector &duu, ON_3dVector &duv, ON_3dVector &dvv, int quadrant=0, int *hint=0) const
ON_BOOL32 | EvNormal (double u, double v, ON_3dPoint &point, ON_3dVector &normal, int quadrant=0, int *hint=0) const
ON_BOOL32 | EvNormal (double u, double v, ON_3dVector &normal, int quadrant=0, int *hint=0) const
ON_BOOL32 | EvNormal (double u, double v, ON_3dPoint &point, ON_3dVector &du, ON_3dVector &dv, ON_3dVector &normal, int=0, int *=0) const
virtual int | HasNurbForm () const
ON_NurbsSurface * | NurbsSurface (ON_NurbsSurface *pNurbsSurface=NULL, double tolerance=0.0, const ON_Interval *s_subdomain=NULL, const ON_Interval *t_subdomain=NULL) const
virtual bool | GetSurfaceParameterFromNurbFormParameter (double nurbs_s, double nurbs_t, double *surface_s, double *surface_t) const
virtual bool | GetNurbFormParameterFromSurfaceParameter (double surface_s, double surface_t, double *nurbs_s, double *nurbs_t) const
void | DestroySurfaceTree ()
Public Member Functions inherited from ON_Geometry
| ON_Geometry ()
| ON_Geometry (const ON_Geometry &)
ON_Geometry & | operator= (const ON_Geometry &)
virtual | ~ON_Geometry ()
ON_BoundingBox | BoundingBox () const
ON_BOOL32 | GetBoundingBox (ON_BoundingBox &bbox, int bGrowBox=false) const
ON_BOOL32 | GetBoundingBox (ON_3dPoint &bbox_min, ON_3dPoint &bbox_max, int bGrowBox=false) const
ON_BOOL32 | Rotate (double sin_angle, double cos_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Rotate (double rotation_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Translate (const ON_3dVector &translation_vector)
ON_BOOL32 | Scale (double scale_factor)
virtual bool | GetTightBoundingBox (ON_BoundingBox &tight_bbox, int bGrowBox=false, const ON_Xform *xform=0) const
virtual void | ClearBoundingBox ()
virtual ON_COMPONENT_INDEX | ComponentIndex () const
Public Member Functions inherited from ON_Object
bool | CopyFrom (const ON_Object *src)
| ON_Object ()
| ON_Object (const ON_Object &)
ON_Object & | operator= (const ON_Object &)
virtual | ~ON_Object ()
void | EmergencyDestroy ()
virtual void | MemoryRelocate ()
ON_BOOL32 | IsKindOf (const ON_ClassId *pClassId) const
virtual ON_UUID | ModelObjectId () const
bool | SetUserString (const wchar_t *key, const wchar_t *string_value)
int | SetUserStrings (int count, const ON_UserString *user_strings, bool bReplace)
bool | GetUserString (const wchar_t *key, ON_wString &string_value) const
int | GetUserStrings (ON_ClassArray< ON_UserString > &user_strings) const
int | GetUserStringKeys (ON_ClassArray< ON_wString > &user_string_keys) const
int | UserStringCount () const
ON_BOOL32 | AttachUserData (ON_UserData *pUserData)
ON_BOOL32 | DetachUserData (ON_UserData *pUserData)
ON_UserData * | GetUserData (const ON_UUID &userdata_uuid) const
void | PurgeUserData ()
ON_UserData * | FirstUserData () const
void | TransformUserData (const ON_Xform &xform)
void | CopyUserData (const ON_Object &source_object)
void | MoveUserData (ON_Object &source_object)

## Static Public Member Functions

static ON_NurbsSurface * | New ()
static ON_NurbsSurface * | New (const ON_NurbsSurface &nurbs_surface)
static ON_NurbsSurface * | New (const ON_BezierSurface &bezier_surface)
static ON_NurbsSurface * | New (int dimension, ON_BOOL32 bIsRational, int order0, int order1, int cv_count0, int cv_count1)

## Public Attributes

int | m_dim
int | m_is_rat
int | m_order [2]
int | m_cv_count [2]
int | m_knot_capacity [2]
double * | m_knot [2]
int | m_cv_stride [2]
int | m_cv_capacity
double * | m_cv

## Additional Inherited Members

Public Types inherited from ON_Surface
enum | ISO { not_iso = 0 , x_iso = 1 , y_iso = 2 , W_iso = 3 , S_iso = 4 , E_iso = 5 , N_iso = 6 , iso_count = 7 }

## Detailed Description

Definition at line 64 of file opennurbs_nurbssurface.h.

## Constructor & Destructor Documentation

## ON_NurbsSurface() [1/4]

ON_NurbsSurface::ON_NurbsSurface | ( |  | ) |

Referenced by GetNurbForm(), IsDuplicate(), New(), New(), New(), New(), ON_NurbsSurface(), operator=(), and operator=().

## ON_NurbsSurface() [2/4]

ON_NurbsSurface::ON_NurbsSurface | ( | const ON_NurbsSurface & | nurbs_surface | ) |

References ON_NurbsSurface().

## ON_NurbsSurface() [3/4]

ON_NurbsSurface::ON_NurbsSurface | ( | const ON_BezierSurface & | bezier_surface | ) |

## ON_NurbsSurface() [4/4]

ON_NurbsSurface::ON_NurbsSurface | ( | int | dimension,
|  | ON_BOOL32 | bIsRational,
|  | int | order0,
|  | int | order1,
|  | int | cv_count0,
|  | int | cv_count1 )

## ~ON_NurbsSurface()

virtual ON_NurbsSurface::~ON_NurbsSurface | ( |  | ) |

virtual

## Member Function Documentation

## ChangeDimension()

bool ON_NurbsSurface::ChangeDimension | ( | int | desired_dimension | ) |

## ChangeSurfaceSeam()

ON_BOOL32 ON_NurbsSurface::ChangeSurfaceSeam | ( | int | dir,
|  | double | t )

## ClampEnd()

bool ON_NurbsSurface::ClampEnd | ( | int | dir,
|  | int | end )

## CollapseSide()

bool ON_NurbsSurface::CollapseSide | ( | int | side,
|  | ON_3dPoint | point = ON_unset_point )

## ControlPolygonLength()

double ON_NurbsSurface::ControlPolygonLength | ( | int | dir | ) | const

## ConvertSpanToBezier()

ON_BOOL32 ON_NurbsSurface::ConvertSpanToBezier | ( | int | span_index0,
|  | int | span_index1,
|  | ON_BezierSurface & | bezier_surface ) const

## Create()

ON_BOOL32 ON_NurbsSurface::Create | ( | int | dim,
|  | ON_BOOL32 | is_rat,
|  | int | order0,
|  | int | order1,
|  | int | cv_count0,
|  | int | cv_count1 )

## CreateConeSurface()

int ON_NurbsSurface::CreateConeSurface | ( | ON_3dPoint | apex_point,
|  | const ON_Curve & | curve,
|  | const ON_Interval * | curve_domain = NULL )

## CreateRuledSurface()

virtual int ON_NurbsSurface::CreateRuledSurface | ( | const ON_Curve & | curveA,
|  | const ON_Curve & | curveB,
|  | const ON_Interval * | curveA_domain = NULL,
|  | const ON_Interval * | curveB_domain = NULL )

virtual

## CV()

double * ON_NurbsSurface::CV | ( | int | i,
|  | int | j ) const

## CVCount() [1/2]

int ON_NurbsSurface::CVCount | ( | int |  | ) | const

## CVCount() [2/2]

int ON_NurbsSurface::CVCount | ( | void |  | ) | const

## CVSize()

int ON_NurbsSurface::CVSize | ( | void |  | ) | const

## CVStyle()

ON::point_style ON_NurbsSurface::CVStyle | ( |  | ) | const

## DataCRC()

ON__UINT32 ON_NurbsSurface::DataCRC | ( | ON__UINT32 | current_remainder | ) | const

virtual

Reimplemented from ON_Object.

## Degree()

int ON_NurbsSurface::Degree | ( | int |  | ) | const

virtual

Implements ON_Surface.

## Destroy()

void ON_NurbsSurface::Destroy | ( |  | ) |

## Dimension()

int ON_NurbsSurface::Dimension | ( |  | ) | const

virtual

Implements ON_Geometry.

## Domain()

ON_Interval ON_NurbsSurface::Domain | ( | int |  | ) | const

virtual

Implements ON_Surface.

## Dump()

void ON_NurbsSurface::Dump | ( | ON_TextLog & |  | ) | const

virtual

Reimplemented from ON_Object.

## EmergencyDestroy()

void ON_NurbsSurface::EmergencyDestroy | ( |  | ) |

## Evaluate()

ON_BOOL32 ON_NurbsSurface::Evaluate | ( | double | ,
|  | double | ,
|  | int | ,
|  | int | ,
|  | double * | ,
|  | int | = 0,
|  | int * | = 0 ) const

virtual

Implements ON_Surface.

## Extend()

bool ON_NurbsSurface::Extend | ( | int | dir,
|  | const ON_Interval & | domain )

virtual

Reimplemented from ON_Surface.

## GetBBox()

ON_BOOL32 ON_NurbsSurface::GetBBox | ( | double * | ,
|  | double * | ,
|  | ON_BOOL32 | = false ) const

virtual

Implements ON_Geometry.

## GetCV() [1/3]

ON_BOOL32 ON_NurbsSurface::GetCV | ( | int | i,
|  | int | j,
|  | ON::point_style | ,
|  | double * | cv ) const

## GetCV() [2/3]

ON_BOOL32 ON_NurbsSurface::GetCV | ( | int | i,
|  | int | j,
|  | ON_3dPoint & | cv ) const

## GetCV() [3/3]

ON_BOOL32 ON_NurbsSurface::GetCV | ( | int | i,
|  | int | j,
|  | ON_4dPoint & | cv ) const

## GetGrevilleAbcissae()

bool ON_NurbsSurface::GetGrevilleAbcissae | ( | int | dir,
|  | double * | g ) const

## GetNextDiscontinuity()

bool ON_NurbsSurface::GetNextDiscontinuity | ( | int | dir,
|  | ON::continuity | c,
|  | double | t0,
|  | double | t1,
|  | double * | t,
|  | int * | hint = NULL,
|  | int * | dtype = NULL,
|  | double | cos_angle_tolerance = ON_DEFAULT_ANGLE_TOLERANCE_COSINE,
|  | double | curvature_tolerance = ON_SQRT_EPSILON ) const

virtual

Reimplemented from ON_Surface.

## GetNurbForm()

int ON_NurbsSurface::GetNurbForm | ( | ON_NurbsSurface & | ,
|  | double | = 0.0 ) const

virtual

Reimplemented from ON_Surface.

References ON_NurbsSurface().

## GetParameterTolerance()

ON_BOOL32 ON_NurbsSurface::GetParameterTolerance | ( | int | ,
|  | double | ,
|  | double * | ,
|  | double * | ) const

virtual

Reimplemented from ON_Surface.

## GetSpanVector()

ON_BOOL32 ON_NurbsSurface::GetSpanVector | ( | int | ,
|  | double * | ) const

virtual

Implements ON_Surface.

## GetSurfaceSize()

ON_BOOL32 ON_NurbsSurface::GetSurfaceSize | ( | double * | width,
|  | double * | height ) const

virtual

Reimplemented from ON_Surface.

## GrevilleAbcissa()

double ON_NurbsSurface::GrevilleAbcissa | ( | int | dir,
|  | int | cv_index ) const

## IncreaseDegree()

bool ON_NurbsSurface::IncreaseDegree | ( | int | dir,
|  | int | desired_degree )

## Initialize()

void ON_NurbsSurface::Initialize | ( | void |  | ) |

## InsertKnot()

bool ON_NurbsSurface::InsertKnot | ( | int | dir,
|  | double | knot_value,
|  | int | knot_multiplicity = 1 )

## IsClamped()

bool ON_NurbsSurface::IsClamped | ( | int | dir,
|  | int | end = 2 ) const

## IsClosed()

ON_BOOL32 ON_NurbsSurface::IsClosed | ( | int |  | ) | const

virtual

Reimplemented from ON_Surface.

## IsContinuous()

bool ON_NurbsSurface::IsContinuous | ( | ON::continuity | c,
|  | double | s,
|  | double | t,
|  | int * | hint = NULL,
|  | double | point_tolerance = ON_ZERO_TOLERANCE,
|  | double | d1_tolerance = ON_ZERO_TOLERANCE,
|  | double | d2_tolerance = ON_ZERO_TOLERANCE,
|  | double | cos_angle_tolerance = ON_DEFAULT_ANGLE_TOLERANCE_COSINE,
|  | double | curvature_tolerance = ON_SQRT_EPSILON ) const

virtual

Reimplemented from ON_Surface.

## IsDeformable()

bool ON_NurbsSurface::IsDeformable | ( |  | ) | const

virtual

Reimplemented from ON_Geometry.

## IsDuplicate()

bool ON_NurbsSurface::IsDuplicate | ( | const ON_NurbsSurface & | other,
|  | bool | bIgnoreParameterization,
|  | double | tolerance = ON_ZERO_TOLERANCE ) const

References ON_NurbsSurface().

## IsoCurve()

ON_Curve * ON_NurbsSurface::IsoCurve | ( | int | dir,
|  | double | c ) const

virtual

Reimplemented from ON_Surface.

## IsPeriodic()

ON_BOOL32 ON_NurbsSurface::IsPeriodic | ( | int |  | ) | const

virtual

Reimplemented from ON_Surface.

## IsPlanar()

ON_BOOL32 ON_NurbsSurface::IsPlanar | ( | ON_Plane * | plane = NULL,
|  | double | tolerance = ON_ZERO_TOLERANCE ) const

virtual

Reimplemented from ON_Surface.

## IsRational()

bool ON_NurbsSurface::IsRational | ( | void |  | ) | const

## IsSingular()

ON_BOOL32 ON_NurbsSurface::IsSingular | ( | int |  | ) | const

virtual

Reimplemented from ON_Surface.

## IsValid()

ON_BOOL32 ON_NurbsSurface::IsValid | ( | ON_TextLog * | text_log = NULL | ) | const

virtual

Implements ON_Object.

## Knot() [1/2]

const double * ON_NurbsSurface::Knot | ( | int | dir | ) | const

## Knot() [2/2]

double ON_NurbsSurface::Knot | ( | int | dir,
|  | int | knot_index ) const

## KnotCount()

int ON_NurbsSurface::KnotCount | ( | int | dir | ) | const

## KnotMultiplicity()

int ON_NurbsSurface::KnotMultiplicity | ( | int | dir,
|  | int | knot_index ) const

## MakeClampedUniformKnotVector()

bool ON_NurbsSurface::MakeClampedUniformKnotVector | ( | int | dir,
|  | double | delta = 1.0 )

## MakeDeformable()

bool ON_NurbsSurface::MakeDeformable | ( |  | ) |

virtual

Reimplemented from ON_Geometry.

## MakeNonRational()

bool ON_NurbsSurface::MakeNonRational | ( |  | ) |

## MakePeriodicUniformKnotVector()

bool ON_NurbsSurface::MakePeriodicUniformKnotVector | ( | int | dir,
|  | double | delta = 1.0 )

## MakeRational()

bool ON_NurbsSurface::MakeRational | ( |  | ) |

## New() [1/4]

ON_NurbsSurface * ON_NurbsSurface::New | ( |  | ) |

static

References ON_NurbsSurface().

## New() [2/4]

ON_NurbsSurface * ON_NurbsSurface::New | ( | const ON_BezierSurface & | bezier_surface | ) |

static

References ON_NurbsSurface().

## New() [3/4]

ON_NurbsSurface * ON_NurbsSurface::New | ( | const ON_NurbsSurface & | nurbs_surface | ) |

static

References ON_NurbsSurface().

## New() [4/4]

ON_NurbsSurface * ON_NurbsSurface::New | ( | int | dimension,
|  | ON_BOOL32 | bIsRational,
|  | int | order0,
|  | int | order1,
|  | int | cv_count0,
|  | int | cv_count1 )

static

References ON_NurbsSurface().

## Offset()

ON_Surface * ON_NurbsSurface::Offset | ( | double | offset_distance,
|  | double | tolerance,
|  | double * | max_deviation = NULL ) const

References ON_Surface::ON_Surface().

## operator=() [1/2]

ON_NurbsSurface & ON_NurbsSurface::operator= | ( | const ON_BezierSurface & | bezier_surface | ) |

References ON_NurbsSurface().

## operator=() [2/2]

ON_NurbsSurface & ON_NurbsSurface::operator= | ( | const ON_NurbsSurface & |  | ) |

References ON_NurbsSurface().

## Order()

int ON_NurbsSurface::Order | ( | int |  | ) | const

## Read()

ON_BOOL32 ON_NurbsSurface::Read | ( | ON_BinaryArchive & |  | ) |

virtual

Reimplemented from ON_Object.

## ReserveCVCapacity()

ON_BOOL32 ON_NurbsSurface::ReserveCVCapacity | ( | int | cv_array_capacity | ) |

## ReserveKnotCapacity()

ON_BOOL32 ON_NurbsSurface::ReserveKnotCapacity | ( | int | dir,
|  | int | knot_array_capacity )

## Reverse()

ON_BOOL32 ON_NurbsSurface::Reverse | ( | int |  | ) |

virtual

Implements ON_Surface.

## SetClampedGrevilleKnotVector()

bool ON_NurbsSurface::SetClampedGrevilleKnotVector | ( | int | dir,
|  | int | g_stride,
|  | const double * | g )

## SetCV() [1/3]

ON_BOOL32 ON_NurbsSurface::SetCV | ( | int | i,
|  | int | j,
|  | const ON_3dPoint & | cv )

## SetCV() [2/3]

ON_BOOL32 ON_NurbsSurface::SetCV | ( | int | i,
|  | int | j,
|  | const ON_4dPoint & | cv )

## SetCV() [3/3]

ON_BOOL32 ON_NurbsSurface::SetCV | ( | int | i,
|  | int | j,
|  | ON::point_style | ,
|  | const double * | cv )

## SetCVColumn() [1/2]

ON_BOOL32 ON_NurbsSurface::SetCVColumn | ( | int | col_index,
|  | const ON_3dPoint & | cv )

## SetCVColumn() [2/2]

ON_BOOL32 ON_NurbsSurface::SetCVColumn | ( | int | col_index,
|  | int | v_stride,
|  | const double * | v )

## SetCVRow() [1/2]

ON_BOOL32 ON_NurbsSurface::SetCVRow | ( | int | row_index,
|  | const ON_3dPoint & | cv )

## SetCVRow() [2/2]

ON_BOOL32 ON_NurbsSurface::SetCVRow | ( | int | row_index,
|  | int | v_stride,
|  | const double * | v )

## SetDomain()

ON_BOOL32 ON_NurbsSurface::SetDomain | ( | int | dir,
|  | double | t0,
|  | double | t1 )

virtual

Reimplemented from ON_Surface.

## SetKnot()

int ON_NurbsSurface::SetKnot | ( | int | dir,
|  | int | knot_index,
|  | double | knot_value )

## SetPeriodicGrevilleKnotVector()

bool ON_NurbsSurface::SetPeriodicGrevilleKnotVector | ( | int | dir,
|  | int | g_stride,
|  | const double * | g )

## SetWeight()

ON_BOOL32 ON_NurbsSurface::SetWeight | ( | int | i,
|  | int | j,
|  | double | weight )

## SizeOf()

unsigned int ON_NurbsSurface::SizeOf | ( |  | ) | const

virtual

Reimplemented from ON_Object.

## SpanCount()

int ON_NurbsSurface::SpanCount | ( | int |  | ) | const

virtual

Implements ON_Surface.

## Split()

ON_BOOL32 ON_NurbsSurface::Split | ( | int | dir,
|  | double | c,
|  | ON_Surface *& | west_or_south_side,
|  | ON_Surface *& | east_or_north_side ) const

virtual

Reimplemented from ON_Surface.

References ON_Surface::ON_Surface().

## SuperfluousKnot()

double ON_NurbsSurface::SuperfluousKnot | ( | int | dir,
|  | int | end ) const

## SwapCoordinates()

ON_BOOL32 ON_NurbsSurface::SwapCoordinates | ( | int | ,
|  | int | )

virtual

Reimplemented from ON_Geometry.

## TensorProduct()

ON_BOOL32 ON_NurbsSurface::TensorProduct | ( | const ON_NurbsCurve & | ,
|  | const ON_NurbsCurve & | ,
|  | ON_TensorProduct & | )

## Transform()

ON_BOOL32 ON_NurbsSurface::Transform | ( | const ON_Xform & |  | ) |

virtual

Reimplemented from ON_Geometry.

## Transpose()

ON_BOOL32 ON_NurbsSurface::Transpose | ( |  | ) |

virtual

Implements ON_Surface.

## Trim()

ON_BOOL32 ON_NurbsSurface::Trim | ( | int | dir,
|  | const ON_Interval & | domain )

virtual

Reimplemented from ON_Surface.

## Weight()

double ON_NurbsSurface::Weight | ( | int | i,
|  | int | j ) const

## Write()

ON_BOOL32 ON_NurbsSurface::Write | ( | ON_BinaryArchive & |  | ) | const

virtual

Reimplemented from ON_Object.

## ZeroCVs()

bool ON_NurbsSurface::ZeroCVs | ( |  | ) |

## Member Data Documentation

## m_cv

double* ON_NurbsSurface::m_cv

Definition at line 1015 of file opennurbs_nurbssurface.h.

## m_cv_capacity

int ON_NurbsSurface::m_cv_capacity

Definition at line 1006 of file opennurbs_nurbssurface.h.

## m_cv_count

int ON_NurbsSurface::m_cv_count[2]

Definition at line 983 of file opennurbs_nurbssurface.h.

## m_cv_stride

int ON_NurbsSurface::m_cv_stride[2]

Definition at line 1003 of file opennurbs_nurbssurface.h.

## m_dim

int ON_NurbsSurface::m_dim

Definition at line 974 of file opennurbs_nurbssurface.h.

## m_is_rat

int ON_NurbsSurface::m_is_rat

Definition at line 976 of file opennurbs_nurbssurface.h.

## m_knot

double* ON_NurbsSurface::m_knot[2]

Definition at line 998 of file opennurbs_nurbssurface.h.

## m_knot_capacity

int ON_NurbsSurface::m_knot_capacity[2]

Definition at line 987 of file opennurbs_nurbssurface.h.

## m_order

int ON_NurbsSurface::m_order[2]

Definition at line 981 of file opennurbs_nurbssurface.h.

The documentation for this class was generated from the following file:

- pcl/surface/3rdparty/opennurbs/opennurbs_nurbssurface.h